//Heli Beleuchtung
//für 2S/3S LiPo mit Unterspannungsabschaltung

int pin_RX_Signal = 10;
int pin_PositionLightH = 8;
int pin_PositionLightO = 7;
int pin_Front = 6;
int pin_StrobeLight = 5;
int pin_SearchLight = 4;
int pin_Relais = 2;
int pin_Turbine = 3;
int sensor = A7; // Eingangspin Unterspannungs Überwachung

int RX_Signal;
// Schaltpunkt der LED
int RX_Time = 1200; // Turbine
int RX_Time1 = 1400; // +Positionslichter + ACL
int RX_Time2 = 1700; // +Suchscheinwerfer

unsigned long Time_mem = 0;
unsigned long Intervall = 0;

long random_led;

int min_led = 150; // Minimum Leuchtkraft Turbine (kann je nach Wunsch vrändert werden)
int max_led = 255; // Maximum Leuchtkraft Turbine

void setup() {
  pinMode(pin_PositionLightH, OUTPUT);
  pinMode(pin_PositionLightO, OUTPUT);
  pinMode(pin_Front, OUTPUT);
  pinMode(pin_StrobeLight, OUTPUT);
  pinMode(pin_RX_Signal, INPUT);
  pinMode(pin_SearchLight, OUTPUT);
  pinMode(pin_Relais, OUTPUT);
  pinMode(pin_Turbine, OUTPUT);

  digitalWrite(pin_Relais, HIGH); // Selbsthalte Relais beim einschalten
}

void loop() {
  //  RX_Signal = 1500; //für Testzwecke kann ein Empängersignal imitiert werden,
  //  nächste Zeile muss dann auskommentiert werden

  RX_Signal = pulseIn(pin_RX_Signal, HIGH, 24000);
  if (RX_Signal > RX_Time2)
  {
    digitalWrite(pin_SearchLight, HIGH);
  }
  else
  {
    digitalWrite(pin_SearchLight, LOW);
  }
  if (RX_Signal > RX_Time1)
  {
    digitalWrite(pin_PositionLightH, HIGH);
    digitalWrite(pin_PositionLightO, HIGH);
    digitalWrite(pin_Front, HIGH);
  }
  else
  {
    digitalWrite(pin_PositionLightH, LOW);
    digitalWrite(pin_PositionLightO, LOW);
    digitalWrite(pin_Front, LOW);
  }
  Intervall = millis() - Time_mem;
  if (Intervall > 1100) {
    Time_mem = millis();
  }
  if (RX_Signal > RX_Time1) { //ACL Blitzfolge (3x) 50mS Blitz / 50mS Pause
    if (Intervall < 50) {
      digitalWrite(pin_StrobeLight, HIGH);
    }
    else if (Intervall < 100) {
      digitalWrite(pin_StrobeLight, LOW);
    }
    else if (Intervall < 150) {
      digitalWrite(pin_StrobeLight, HIGH);
    }
    else if (Intervall < 200) {
      digitalWrite(pin_StrobeLight, LOW);
    }
    else if (Intervall < 250) {
      digitalWrite(pin_StrobeLight, HIGH);
    }
    else if (Intervall < 300) {
      digitalWrite(pin_StrobeLight, LOW);
    }

    else {}
  }
  // Unterspannung Überwachung, per Poti auf 10,5V bei 3S einstellen
  int s1 = analogRead(sensor);
  if (s1 < 300) {
    digitalWrite (pin_Relais, LOW);
  }

  //Flackerlicht für Turbinenbeleuchtung
  if (RX_Signal > RX_Time)
  {
    random_led = random(min_led, max_led); // random nummer für Helligkeit der LED
    analogWrite(pin_Turbine, random_led); // PWM Wert setzen
    delay(20); // Zeit des jeweiligen PWM Wert setzen
  }
  else { //Abschalten Turbinen LED und ACL LED
    analogWrite(pin_Turbine, 0);
    digitalWrite(pin_StrobeLight, LOW);
  }
}
